diff --git a/target/linux/apm821xx/config-4.9 b/target/linux/apm821xx/config-4.9
index b31df63..2446a7b 100644
--- a/target/linux/apm821xx/config-4.9
+++ b/target/linux/apm821xx/config-4.9
@@ -301,7 +301,6 @@ CONFIG_SERIAL_8250_EXTENDED=y
 CONFIG_SERIAL_8250_FSL=y
 CONFIG_SERIAL_8250_SHARE_IRQ=y
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 CONFIG_SIMPLE_GPIO=y
 CONFIG_SPARSE_IRQ=y
 CONFIG_SRCU=y
diff --git a/target/linux/arc770/config-4.9 b/target/linux/arc770/config-4.9
index 2472ce2..fb5cd43 100644
--- a/target/linux/arc770/config-4.9
+++ b/target/linux/arc770/config-4.9
@@ -185,7 +185,6 @@ CONFIG_SERIAL_ARC=y
 CONFIG_SERIAL_ARC_CONSOLE=y
 CONFIG_SERIAL_ARC_NR_PORTS=1
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 CONFIG_SRCU=y
 CONFIG_STACKTRACE=y
 CONFIG_STMMAC_ETH=y
diff --git a/target/linux/archs38/config-4.9 b/target/linux/archs38/config-4.9
index 311315e..997a3c2 100644
--- a/target/linux/archs38/config-4.9
+++ b/target/linux/archs38/config-4.9
@@ -198,7 +198,6 @@ CONFIG_SERIAL_ARC=y
 CONFIG_SERIAL_ARC_CONSOLE=y
 CONFIG_SERIAL_ARC_NR_PORTS=1
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 CONFIG_SMP=y
 CONFIG_SRCU=y
 CONFIG_STACKTRACE=y
diff --git a/target/linux/bcm53xx/config-4.9 b/target/linux/bcm53xx/config-4.9
index 3f6b7c3..2859f03 100644
--- a/target/linux/bcm53xx/config-4.9
+++ b/target/linux/bcm53xx/config-4.9
@@ -293,7 +293,6 @@ CONFIG_SERIAL_8250_FSL=y
 # CONFIG_SERIAL_AMBA_PL010 is not set
 # CONFIG_SERIAL_AMBA_PL011 is not set
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 CONFIG_SMP=y
 CONFIG_SMP_ON_UP=y
 CONFIG_SPARSE_IRQ=y
diff --git a/target/linux/brcm2708/bcm2708/config-4.9 b/target/linux/brcm2708/bcm2708/config-4.9
index 7eb5a72..b766b74 100644
--- a/target/linux/brcm2708/bcm2708/config-4.9
+++ b/target/linux/brcm2708/bcm2708/config-4.9
@@ -342,6 +342,7 @@ CONFIG_SERIAL_8250_SHARE_IRQ=y
 CONFIG_SERIAL_AMBA_PL011=y
 CONFIG_SERIAL_AMBA_PL011_CONSOLE=y
 CONFIG_SERIAL_OF_PLATFORM=y
+CONFIG_SG_POOL=y
 CONFIG_SPARSE_IRQ=y
 # CONFIG_SQUASHFS is not set
 CONFIG_SRCU=y
diff --git a/target/linux/brcm2708/bcm2709/config-4.9 b/target/linux/brcm2708/bcm2709/config-4.9
index 9ee2338..26b2c6c 100644
--- a/target/linux/brcm2708/bcm2709/config-4.9
+++ b/target/linux/brcm2708/bcm2709/config-4.9
@@ -370,6 +370,7 @@ CONFIG_SERIAL_8250_SHARE_IRQ=y
 CONFIG_SERIAL_AMBA_PL011=y
 CONFIG_SERIAL_AMBA_PL011_CONSOLE=y
 CONFIG_SERIAL_OF_PLATFORM=y
+CONFIG_SG_POOL=y
 CONFIG_SMP=y
 CONFIG_SMP_ON_UP=y
 CONFIG_SPARSE_IRQ=y
diff --git a/target/linux/brcm2708/bcm2710/config-4.9 b/target/linux/brcm2708/bcm2710/config-4.9
index f672c40..f2f27cf 100644
--- a/target/linux/brcm2708/bcm2710/config-4.9
+++ b/target/linux/brcm2708/bcm2710/config-4.9
@@ -388,6 +388,7 @@ CONFIG_SERIAL_8250_SHARE_IRQ=y
 CONFIG_SERIAL_AMBA_PL011=y
 CONFIG_SERIAL_AMBA_PL011_CONSOLE=y
 CONFIG_SERIAL_OF_PLATFORM=y
+CONFIG_SG_POOL=y
 CONFIG_SMP=y
 CONFIG_SPARSEMEM=y
 CONFIG_SPARSEMEM_EXTREME=y
diff --git a/target/linux/cns3xxx/config-4.9 b/target/linux/cns3xxx/config-4.9
index 2fec4f0..6c07465 100644
--- a/target/linux/cns3xxx/config-4.9
+++ b/target/linux/cns3xxx/config-4.9
@@ -260,6 +260,7 @@ CONFIG_SENSORS_AD7418=y
 CONFIG_SERIAL_8250_FSL=y
 CONFIG_SERIAL_8250_NR_UARTS=3
 CONFIG_SERIAL_8250_RUNTIME_UARTS=3
+CONFIG_SG_POOL=y
 CONFIG_SMP=y
 CONFIG_SMP_ON_UP=y
 CONFIG_SPARSE_IRQ=y
diff --git a/target/linux/generic/config-4.9 b/target/linux/generic/config-4.9
index 1307849..d22ef35 100644
--- a/target/linux/generic/config-4.9
+++ b/target/linux/generic/config-4.9
@@ -3966,7 +3966,7 @@ CONFIG_SERIAL_EARLYCON=y
 # CONFIG_SGI_IP28 is not set
 # CONFIG_SGI_IP32 is not set
 # CONFIG_SGI_PARTITION is not set
-CONFIG_SG_POOL=y
+# CONFIG_SG_POOL is not set
 # CONFIG_SG_SPLIT is not set
 CONFIG_SHMEM=y
 # CONFIG_SH_ETH is not set
diff --git a/target/linux/imx6/config-4.9 b/target/linux/imx6/config-4.9
index 701bb53..590e192 100644
--- a/target/linux/imx6/config-4.9
+++ b/target/linux/imx6/config-4.9
@@ -425,6 +425,7 @@ CONFIG_SERIAL_8250_FSL=y
 CONFIG_SERIAL_IMX=y
 CONFIG_SERIAL_IMX_CONSOLE=y
 CONFIG_SERIAL_MCTRL_GPIO=y
+CONFIG_SG_POOL=y
 CONFIG_SMP=y
 CONFIG_SMP_ON_UP=y
 CONFIG_SOC_BUS=y
diff --git a/target/linux/ipq806x/config-4.9 b/target/linux/ipq806x/config-4.9
index 072ab6a..7e6ec70 100644
--- a/target/linux/ipq806x/config-4.9
+++ b/target/linux/ipq806x/config-4.9
@@ -447,7 +447,6 @@ CONFIG_SERIAL_8250_FSL=y
 # CONFIG_SERIAL_AMBA_PL011 is not set
 CONFIG_SERIAL_MSM=y
 CONFIG_SERIAL_MSM_CONSOLE=y
-# CONFIG_SG_POOL is not set
 CONFIG_SMP=y
 CONFIG_SMP_ON_UP=y
 CONFIG_SPARSE_IRQ=y
diff --git a/target/linux/lantiq/config-4.9 b/target/linux/lantiq/config-4.9
index edfc1c1..52e58ab 100644
--- a/target/linux/lantiq/config-4.9
+++ b/target/linux/lantiq/config-4.9
@@ -183,7 +183,6 @@ CONFIG_SCHED_HRTICK=y
 # CONFIG_SENSORS_LTQ_CPUTEMP is not set
 # CONFIG_SERIAL_8250 is not set
 CONFIG_SERIAL_LANTIQ=y
-# CONFIG_SG_POOL is not set
 # CONFIG_SOC_AMAZON_SE is not set
 # CONFIG_SOC_FALCON is not set
 CONFIG_SOC_TYPE_XWAY=y
diff --git a/target/linux/mediatek/config-4.9 b/target/linux/mediatek/config-4.9
index 9f5b200..268154b 100644
--- a/target/linux/mediatek/config-4.9
+++ b/target/linux/mediatek/config-4.9
@@ -397,7 +397,6 @@ CONFIG_SERIAL_8250_FSL=y
 CONFIG_SERIAL_8250_MT6577=y
 CONFIG_SERIAL_8250_NR_UARTS=4
 CONFIG_SERIAL_8250_RUNTIME_UARTS=4
-# CONFIG_SG_POOL is not set
 CONFIG_SMP=y
 # CONFIG_SMP_ON_UP is not set
 CONFIG_SPARSE_IRQ=y
diff --git a/target/linux/mpc85xx/config-4.9 b/target/linux/mpc85xx/config-4.9
index 9bd8a5d..33b8a51 100644
--- a/target/linux/mpc85xx/config-4.9
+++ b/target/linux/mpc85xx/config-4.9
@@ -315,7 +315,6 @@ CONFIG_SERIAL_8250_FSL=y
 CONFIG_SERIAL_8250_SHARE_IRQ=y
 CONFIG_SERIAL_OF_PLATFORM=y
 # CONFIG_SERIAL_QE is not set
-# CONFIG_SG_POOL is not set
 CONFIG_SIMPLE_GPIO=y
 # CONFIG_SOCRATES is not set
 CONFIG_SPARSE_IRQ=y
diff --git a/target/linux/mvebu/config-4.9 b/target/linux/mvebu/config-4.9
index 3d7bf94..d729dc4 100644
--- a/target/linux/mvebu/config-4.9
+++ b/target/linux/mvebu/config-4.9
@@ -396,6 +396,7 @@ CONFIG_SERIAL_8250_DW=y
 CONFIG_SERIAL_8250_FSL=y
 CONFIG_SERIAL_MVEBU_CONSOLE=y
 CONFIG_SERIAL_MVEBU_UART=y
+CONFIG_SG_POOL=y
 CONFIG_SFP=y
 CONFIG_SMP=y
 CONFIG_SMP_ON_UP=y
diff --git a/target/linux/octeon/config-4.9 b/target/linux/octeon/config-4.9
index b866146..6284b73 100644
--- a/target/linux/octeon/config-4.9
+++ b/target/linux/octeon/config-4.9
@@ -247,6 +247,7 @@ CONFIG_SECCOMP=y
 CONFIG_SECCOMP_FILTER=y
 CONFIG_SERIAL_8250_DW=y
 # CONFIG_SERIAL_8250_FSL is not set
+CONFIG_SG_POOL=y
 CONFIG_SMP=y
 CONFIG_SPARSEMEM=y
 CONFIG_SPARSEMEM_STATIC=y
diff --git a/target/linux/pistachio/config-4.9 b/target/linux/pistachio/config-4.9
index 00af587..0a882e4 100644
--- a/target/linux/pistachio/config-4.9
+++ b/target/linux/pistachio/config-4.9
@@ -284,6 +284,7 @@ CONFIG_SCSI_SPI_ATTRS=y
 CONFIG_SERIAL_8250_DW=y
 # CONFIG_SERIAL_8250_FSL is not set
 CONFIG_SERIAL_OF_PLATFORM=y
+CONFIG_SG_POOL=y
 CONFIG_SMP=y
 CONFIG_SMP_UP=y
 CONFIG_SPI=y
diff --git a/target/linux/ramips/mt7620/config-4.9 b/target/linux/ramips/mt7620/config-4.9
index 508f548..2c1d1bc 100644
--- a/target/linux/ramips/mt7620/config-4.9
+++ b/target/linux/ramips/mt7620/config-4.9
@@ -187,7 +187,6 @@ CONFIG_SCHED_HRTICK=y
 # CONFIG_SERIAL_8250_FSL is not set
 CONFIG_SERIAL_8250_RT288X=y
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 CONFIG_SOC_MT7620=y
 # CONFIG_SOC_MT7621 is not set
 # CONFIG_SOC_RT288X is not set
diff --git a/target/linux/ramips/mt7621/config-4.9 b/target/linux/ramips/mt7621/config-4.9
index d531a2d..b7f12e3 100644
--- a/target/linux/ramips/mt7621/config-4.9
+++ b/target/linux/ramips/mt7621/config-4.9
@@ -241,7 +241,6 @@ CONFIG_SCHED_SMT=y
 CONFIG_SERIAL_8250_NR_UARTS=3
 CONFIG_SERIAL_8250_RUNTIME_UARTS=3
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 CONFIG_SMP=y
 CONFIG_SMP_UP=y
 # CONFIG_SOC_MT7620 is not set
diff --git a/target/linux/ramips/mt7628/config-4.9 b/target/linux/ramips/mt7628/config-4.9
index 6f8e7f1..6f0962f 100644
--- a/target/linux/ramips/mt7628/config-4.9
+++ b/target/linux/ramips/mt7628/config-4.9
@@ -183,7 +183,6 @@ CONFIG_SCHED_HRTICK=y
 CONFIG_SERIAL_8250_NR_UARTS=3
 CONFIG_SERIAL_8250_RUNTIME_UARTS=3
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 CONFIG_SOC_MT7620=y
 # CONFIG_SOC_MT7621 is not set
 # CONFIG_SOC_RT288X is not set
diff --git a/target/linux/ramips/mt7688/config-4.9 b/target/linux/ramips/mt7688/config-4.9
index 5e1290b..1e89b77 100644
--- a/target/linux/ramips/mt7688/config-4.9
+++ b/target/linux/ramips/mt7688/config-4.9
@@ -183,7 +183,6 @@ CONFIG_SCHED_HRTICK=y
 CONFIG_SERIAL_8250_NR_UARTS=3
 CONFIG_SERIAL_8250_RUNTIME_UARTS=3
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 CONFIG_SOC_MT7620=y
 # CONFIG_SOC_MT7621 is not set
 # CONFIG_SOC_RT288X is not set
diff --git a/target/linux/ramips/rt288x/config-4.9 b/target/linux/ramips/rt288x/config-4.9
index 5864009..01f4f21 100644
--- a/target/linux/ramips/rt288x/config-4.9
+++ b/target/linux/ramips/rt288x/config-4.9
@@ -175,7 +175,6 @@ CONFIG_SCHED_HRTICK=y
 # CONFIG_SERIAL_8250_FSL is not set
 CONFIG_SERIAL_8250_RT288X=y
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 # CONFIG_SOC_MT7620 is not set
 # CONFIG_SOC_MT7621 is not set
 CONFIG_SOC_RT288X=y
diff --git a/target/linux/ramips/rt305x/config-4.9 b/target/linux/ramips/rt305x/config-4.9
index feacc95..0009a58 100644
--- a/target/linux/ramips/rt305x/config-4.9
+++ b/target/linux/ramips/rt305x/config-4.9
@@ -172,7 +172,6 @@ CONFIG_SCHED_HRTICK=y
 # CONFIG_SERIAL_8250_FSL is not set
 CONFIG_SERIAL_8250_RT288X=y
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 # CONFIG_SOC_MT7620 is not set
 # CONFIG_SOC_MT7621 is not set
 # CONFIG_SOC_RT288X is not set
diff --git a/target/linux/ramips/rt3883/config-4.9 b/target/linux/ramips/rt3883/config-4.9
index eb77d34..c632ea5 100644
--- a/target/linux/ramips/rt3883/config-4.9
+++ b/target/linux/ramips/rt3883/config-4.9
@@ -180,7 +180,6 @@ CONFIG_SCHED_HRTICK=y
 # CONFIG_SERIAL_8250_FSL is not set
 CONFIG_SERIAL_8250_RT288X=y
 CONFIG_SERIAL_OF_PLATFORM=y
-# CONFIG_SG_POOL is not set
 # CONFIG_SOC_MT7620 is not set
 # CONFIG_SOC_MT7621 is not set
 # CONFIG_SOC_RT288X is not set
diff --git a/target/linux/x86/config-4.9 b/target/linux/x86/config-4.9
index 075b4f0..289a554 100644
--- a/target/linux/x86/config-4.9
+++ b/target/linux/x86/config-4.9
@@ -383,6 +383,7 @@ CONFIG_SERIO=y
 CONFIG_SERIO_I8042=y
 CONFIG_SERIO_LIBPS2=y
 CONFIG_SERIO_SERPORT=y
+CONFIG_SG_POOL=y
 # CONFIG_SMSC37B787_WDT is not set
 # CONFIG_SMSC_SCH311X_WDT is not set
 CONFIG_SPARSEMEM_STATIC=y