diff --git a/target/linux/ath79/dts/ar7161_netgear_wndr3800.dts b/target/linux/ath79/dts/ar7161_netgear_wndr3800.dts
index ba6e9ae03c..a175fd7698 100644
--- a/target/linux/ath79/dts/ar7161_netgear_wndr3800.dts
+++ b/target/linux/ath79/dts/ar7161_netgear_wndr3800.dts
@@ -139,26 +139,32 @@
 		reg = <0>;
 		spi-max-frequency = <25000000>;
 
-		partition@0 {
-			label = "u-boot";
-			reg = <0x000000 0x050000>;
-			read-only;
-		};
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			partition@0 {
+				label = "u-boot";
+				reg = <0x000000 0x050000>;
+				read-only;
+			};
 
-		partition@1 {
-			label = "u-boot-env";
-			reg = <0x050000 0x020000>;
-		};
+			partition@1 {
+				label = "u-boot-env";
+				reg = <0x050000 0x020000>;
+			};
 
-		partition@2 {
-			label = "firmware";
-			reg = <0x70000 0xf80000>;
-		};
+			partition@2 {
+				label = "firmware";
+				reg = <0x70000 0xf80000>;
+			};
 
-		partition@3 {
-			label = "art";
-			reg = <0xff0000 0x010000>;
-			read-only;
+			partition@3 {
+				label = "art";
+				reg = <0xff0000 0x010000>;
+				read-only;
+			};
 		};
 	};
 };
diff --git a/target/linux/ath79/dts/ar7241_ubnt-unifi.dts b/target/linux/ath79/dts/ar7241_ubnt-unifi.dts
index aaafb08424..1fa2d82db3 100644
--- a/target/linux/ath79/dts/ar7241_ubnt-unifi.dts
+++ b/target/linux/ath79/dts/ar7241_ubnt-unifi.dts
@@ -68,37 +68,43 @@
 		reg = <0>;
 		spi-max-frequency = <25000000>;
 
-		partition@0 {
-			label = "u-boot";
-			reg = <0x000000 0x040000>;
-		};
-
-		partition@1 {
-			label = "u-boot-env";
-			reg = <0x040000 0x010000>;
-		};
-
-		partition@2 {
-			label = "firmware";
-			reg = <0x050000 0x750000>;
-		};
-
-		partition@3 {
-			label = "board_config";
-			reg = <0x7a0000 0x010000>;
-			read-only;
-		};
-
-		partition@4 {
-			label = "cfg";
-			reg = <0x7b0000 0x040000>;
-			read-only;
-		};
-
-		art: partition@5 {
-			label = "art";
-			reg = <0x7f0000 0x010000>;
-			read-only;
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			partition@0 {
+				label = "u-boot";
+				reg = <0x000000 0x040000>;
+			};
+
+			partition@1 {
+				label = "u-boot-env";
+				reg = <0x040000 0x010000>;
+			};
+
+			partition@2 {
+				label = "firmware";
+				reg = <0x050000 0x750000>;
+			};
+
+			partition@3 {
+				label = "board_config";
+				reg = <0x7a0000 0x010000>;
+				read-only;
+			};
+
+			partition@4 {
+				label = "cfg";
+				reg = <0x7b0000 0x040000>;
+				read-only;
+			};
+
+			art: partition@5 {
+				label = "art";
+				reg = <0x7f0000 0x010000>;
+				read-only;
+			};
 		};
 	};
 };
diff --git a/target/linux/ath79/dts/ar7241_ubnt-xm.dtsi b/target/linux/ath79/dts/ar7241_ubnt-xm.dtsi
index cd7da2089b..ac0a79dc9d 100644
--- a/target/linux/ath79/dts/ar7241_ubnt-xm.dtsi
+++ b/target/linux/ath79/dts/ar7241_ubnt-xm.dtsi
@@ -77,37 +77,43 @@
 		reg = <0>;
 		spi-max-frequency = <25000000>;
 
-		partition@0 {
-			label = "u-boot";
-			reg = <0x000000 0x040000>;
-		};
-
-		partition@1 {
-			label = "u-boot-env";
-			reg = <0x040000 0x010000>;
-		};
-
-		partition@2 {
-			label = "firmware";
-			reg = <0x050000 0x750000>;
-		};
-
-		partition@3 {
-			label = "board_config";
-			reg = <0x7a0000 0x010000>;
-			read-only;
-		};
-
-		partition@4 {
-			label = "cfg";
-			reg = <0x7b0000 0x040000>;
-			read-only;
-		};
-
-		art: partition@5 {
-			label = "art";
-			reg = <0x7f0000 0x010000>;
-			read-only;
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			partition@0 {
+				label = "u-boot";
+				reg = <0x000000 0x040000>;
+			};
+
+			partition@1 {
+				label = "u-boot-env";
+				reg = <0x040000 0x010000>;
+			};
+
+			partition@2 {
+				label = "firmware";
+				reg = <0x050000 0x750000>;
+			};
+
+			partition@3 {
+				label = "board_config";
+				reg = <0x7a0000 0x010000>;
+				read-only;
+			};
+
+			partition@4 {
+				label = "cfg";
+				reg = <0x7b0000 0x040000>;
+				read-only;
+			};
+
+			art: partition@5 {
+				label = "art";
+				reg = <0x7f0000 0x010000>;
+				read-only;
+			};
 		};
 	};
 };
diff --git a/target/linux/ath79/dts/ar9132_tl_wr1043nd_v1.dts b/target/linux/ath79/dts/ar9132_tl_wr1043nd_v1.dts
index 9589925eb5..40db55bc32 100644
--- a/target/linux/ath79/dts/ar9132_tl_wr1043nd_v1.dts
+++ b/target/linux/ath79/dts/ar9132_tl_wr1043nd_v1.dts
@@ -94,20 +94,26 @@
 		reg = <0>;
 		spi-max-frequency = <25000000>;
 
-		partition@0 {
-			label = "u-boot";
-			reg = <0x000000 0x020000>;
-		};
-
-		partition@1 {
-			label = "firmware";
-			reg = <0x020000 0x7D0000>;
-		};
-
-		partition@2 {
-			label = "art";
-			reg = <0x7F0000 0x010000>;
-			read-only;
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			partition@0 {
+				label = "u-boot";
+				reg = <0x000000 0x020000>;
+			};
+
+			partition@1 {
+				label = "firmware";
+				reg = <0x020000 0x7D0000>;
+			};
+
+			partition@2 {
+				label = "art";
+				reg = <0x7F0000 0x010000>;
+				read-only;
+			};
 		};
 	};
 };
diff --git a/target/linux/ath79/dts/ar9330_gl_ar150.dts b/target/linux/ath79/dts/ar9330_gl_ar150.dts
index a41799f0dc..97beab1490 100644
--- a/target/linux/ath79/dts/ar9330_gl_ar150.dts
+++ b/target/linux/ath79/dts/ar9330_gl_ar150.dts
@@ -96,26 +96,32 @@
 		spi-max-frequency = <104000000>;
 		reg = <0>;
 
-		partition@0 {
-			label = "u-boot";
-			reg = <0x000000 0x040000>;
-			read-only;
-		};
-
-		partition@1 {
-			label = "u-boot-env";
-			reg = <0x040000 0x010000>;
-		};
-
-		partition@2 {
-			label = "firmware";
-			reg = <0x050000 0xfa0000>;
-		};
-
-		art: partition@3 {
-			label = "ART";
-			reg = <0xff0000 0x010000>;
-			read-only;
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			partition@0 {
+				label = "u-boot";
+				reg = <0x000000 0x040000>;
+				read-only;
+			};
+
+			partition@1 {
+				label = "u-boot-env";
+				reg = <0x040000 0x010000>;
+			};
+
+			partition@2 {
+				label = "firmware";
+				reg = <0x050000 0xfa0000>;
+			};
+
+			art: partition@3 {
+				label = "ART";
+				reg = <0xff0000 0x010000>;
+				read-only;
+			};
 		};
 	};
 };
diff --git a/target/linux/ath79/dts/ar9331_ew_dorin.dts b/target/linux/ath79/dts/ar9331_ew_dorin.dts
index 3c2a1b2147..fd18593807 100644
--- a/target/linux/ath79/dts/ar9331_ew_dorin.dts
+++ b/target/linux/ath79/dts/ar9331_ew_dorin.dts
@@ -77,26 +77,32 @@
 		spi-max-frequency = <104000000>;
 		reg = <0>;
 
-		partition@0 {
-			label = "u-boot";
-			reg = <0x000000 0x040000>;
-			read-only;
-		};
-
-		partition@1 {
-			label = "u-boot-env";
-			reg = <0x040000 0x010000>;
-		};
-
-		partition@2 {
-			label = "firmware";
-			reg = <0x050000 0xfa0000>;
-		};
-
-		art: partition@3 {
-			label = "ART";
-			reg = <0xff0000 0x010000>;
-			read-only;
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			partition@0 {
+				label = "u-boot";
+				reg = <0x000000 0x040000>;
+				read-only;
+			};
+
+			partition@1 {
+				label = "u-boot-env";
+				reg = <0x040000 0x010000>;
+			};
+
+			partition@2 {
+				label = "firmware";
+				reg = <0x050000 0xfa0000>;
+			};
+
+			art: partition@3 {
+				label = "ART";
+				reg = <0xff0000 0x010000>;
+				read-only;
+			};
 		};
 	};
 };
diff --git a/target/linux/ath79/dts/qca9558_om5p_ac.dts b/target/linux/ath79/dts/qca9558_om5p_ac.dts
index 517bc17cd7..974b1c61f0 100644
--- a/target/linux/ath79/dts/qca9558_om5p_ac.dts
+++ b/target/linux/ath79/dts/qca9558_om5p_ac.dts
@@ -113,26 +113,32 @@
 		reg = <0>;
 		spi-max-frequency = <25000000>;
 
-		partition@0 {
-			label = "u-boot";
-			reg = <0x000000 0x040000>;
-			read-only;
-		};
-
-		partition@1 {
-			label = "u-boot-env";
-			reg = <0x040000 0x010000>;
-		};
-
-		partition@2 {
-			label = "firmware";
-			reg = <0x850000 0x7a0000>;
-		};
-
-		partition@3 {
-			label = "ART";
-			reg = <0xff0000 0x010000>;
-			read-only;
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			partition@0 {
+				label = "u-boot";
+				reg = <0x000000 0x040000>;
+				read-only;
+			};
+
+			partition@1 {
+				label = "u-boot-env";
+				reg = <0x040000 0x010000>;
+			};
+
+			partition@2 {
+				label = "firmware";
+				reg = <0x850000 0x7a0000>;
+			};
+
+			partition@3 {
+				label = "ART";
+				reg = <0xff0000 0x010000>;
+				read-only;
+			};
 		};
 	};
 };